/************************************/
/* Prvni projekt z GPG              */
/* Program pro kresleni kuzelosecek */
/* Autor: Martin KOSTURIK     @1997 */
/************************************/

#include <dos.h>
#include <stdio.h>
#include <graphics.h>
#include <conio.h>
#include <ctype.h>
#include <stdlib.h>
#include <math.h>

#define   AX     rg.x.ax                /* definovani registru    */
#define   BX     rg.x.bx
#define   CX     rg.x.cx
#define   DX     rg.x.dx
#define   INT    int86(0x33, &rg, &rg)  /* preruseni ovladace mysi */

typedef struct {double x, y;} bod;
bod bod_kuzelosecky[6];

bod *prusecik_2primek(bod *A, bod *B, bod *C, bod *D);
int  reset(void);
void en(void);
void dis(void);
void rangex(int min_x, int max_x);
void rangey(int min_y, int max_y);
int  status(int button_mask, int *x, int *y);
void zadani_5bodu(void);
void pascal_veta(void);
void chyba(void);


void main(void)
{
	int i, mx, my, key;
	int graph_driver = DETECT, graph_mode = VGAHI, grchyba;

	grchyba = registerbgidriver(EGAVGA_driver);
	if(grchyba < 0) {
		printf("\nChyba grafiky: %s", grapherrormsg(grchyba));
		exit(1);
	}
	initgraph(&graph_driver,&graph_mode, "");

	if(!reset()) {					/* inicializace ovladace mysi*/
		printf("\nDriver mysi neni nainstalovan !");
		_setcursortype(_NORMALCURSOR);            /* zapnuti kurzoru */
		exit(1);
	}
	rangex(20, 625);
	rangey(20, 459);

	_setcursortype(_NOCURSOR);      			/* inicializace GUI */
	cleardevice();
	setbkcolor(BLACK);
	setfillstyle(SOLID_FILL, RED);
	bar(0, 0, 19, 479);
	bar(19, 0, 540, 19);
	bar(19, 460, 540, 479);
	bar(540, 0, 639, 479);
	settextstyle(DEFAULT_FONT, HORIZ_DIR, 1);
	settextjustify(CENTER_TEXT, CENTER_TEXT);
	setcolor(YELLOW);
	outtextxy(290, 10, "KRESLENI KUZELOSECEK ZADANIM PETI BODU");
	outtextxy(590, 50, "Martin");
	outtextxy(590, 60, "KOSTURIK");
	outtextxy(590, 70, "@1997");
	ellipse(590, 140, 0, 360, 30, 15);
	ellipse(590, 190, 0, 360, 30, 15);
	ellipse(590, 240, 0, 360, 30, 15);
	setcolor(WHITE);
	outtextxy(590, 140, "Start");
	outtextxy(590, 190, "Smaz");
	outtextxy(590, 240, "Konec");
	outtextxy(290, 470, "Klikni na 'Start' ...");
	setviewport(20, 20, 539, 479, 1);

	en();                            		/* zobrazeni kurzoru mysi */

	while(1) {

		if(kbhit()) {
			key = getch();
			if(key == 'q' || key == 'Q') 		/* ukonceni klavesou 'Q'*/
				break;
		}

		i = status(3, &mx, &my);                /* cteni pozice mysi */

		if(i == 1 && mx > 530) {
			if(my > 105 && my < 135) {         /* button Start */
				bar(0, 440, 519, 459);
				outtextxy(270, 450, "Pomoci mysi zadej pet bodu.");
				zadani_5bodu();
				pascal_veta();
				bar(0, 440, 519, 459);
			}
			if(my > 155 && my < 185) {         /* button Smaz */
				clearviewport();
				bar(0, 440, 519, 459);
			}
			if(my > 205 && my < 235) break;    /* button Konec */
		}
	}

	dis();                           /* skryje kurzor mysi           */
	cleardevice();
	closegraph();                    /* ukonceni grafickeho modu  */
	_setcursortype(_NORMALCURSOR);            /* zapnuti kurzoru */
return;
}

int reset(void)
{
	 union REGS   rg;          /* Reset genius mouse driveru        */
	 AX = 0;
	 INT;                      /* zisteni zda je driver nainstalovan */
	 return AX;
}

/*             Povoleni zobrazeni kurzoru mysi                    */
void en(void)
{
	 union REGS   rg;
	 AX = 1;
	 INT;
return;
}

/*               Zakaz zobrazeni kurzoru mysi                      */
void dis(void)
{
	 union REGS   rg;
	 AX = 2;
	 INT;
return;
}

/*       Nastaveni rozsahu pohybu kurzoru v x-ov ose             */
void rangex(int min_x, int max_x)
{
	 union REGS   rg;

	 CX = min_x;
	 DX = max_x;
	 AX = 7;
	 INT;
return;
}

/*       Nastaveni rozsahu pohybu kurzoru v y-ove ose             */
void rangey(int min_y, int max_y)
{
	 union REGS   rg;

	 CX = min_y;
	 DX = max_y;
	 AX = 8;
	 INT;
return;
}

/*   Cteni stavu mysi, t.j. polohy kurzoru a stlaceni tlacitek  */
int status(int button_mask, int *x, int *y)
{
	union REGS	rg;

	AX = 3;
	BX = button_mask;                     /* bitova maska tlacitek */
	INT;
	*x = CX - 20;                         /* aktualni souradnice x a y */
	*y = DX - 20;                         /* minus 20 => 'setviewport' */
	if(*x > 519) {
		gotoxy(72, 24);
		printf("      ");
		gotoxy(72, 25);
		printf("      ");
	}
	else	{
		gotoxy(72, 24);
		printf("X=%4d", *x);
		gotoxy(72, 25);
		printf("Y=%4d", *y);
	}
return BX;
}

void zadani_5bodu(void)
{
	int i, n, mx, my;
	char number[1];

	rangex(20, 539);
	delay(300);
	for(n = 1;n < 6;) {
		i = status(3, &mx, &my);
		if (i == 1) {
			dis();
			putpixel(mx,my, WHITE);         /* kresleni bodu */
			setcolor(LIGHTGREEN);
			circle(mx, my, 4);
			setcolor(WHITE);
			sprintf(number,"%d", n);
			outtextxy(mx-10,my-10, number);
			en();
			bod_kuzelosecky[n].x = mx;
			bod_kuzelosecky[n].y = my;
			++n;
			delay(300);
		}
	}
	rangex(20, 625);

return;
}

/* Prusecik dvou primek */
bod *prusecik_2primek(bod *A, bod *B, bod *C, bod *D)
{
	bod prusecik;
	const bod AB = {B->x - A->x, B->y - A->y},
			CD = {D->x - C->x, D->y - C->y};
	const double tmp1  = -AB.x * CD.y,
			   tmp2  =  AB.y * CD.x,
			   rovnb =  tmp1 + tmp2;

	if(rovnb) {
		prusecik.x = (C->x * tmp1 + (C->y - A->y) * AB.x * CD.x +
				    A->x * tmp2) / rovnb;
		prusecik.y = (A->y * tmp1 + (A->x - C->x) * AB.y * CD.y +
				    C->y * tmp2) / rovnb;
		return(&prusecik);
	}
	else	return(NULL);
}

/* Algoritmus resici Brianch-Pascalovu vetu */
void pascal_veta(void)
{
	int a, b, c, n = 0;
	const double delta = .00017453L;
	double alfa;
	bod *stred, I, II, III, ab, ac;

	for(a = 1; a < 6; ++a) {              /* test zda libovolne tri body */
		for(b = 1; b < 6; ++b) {         /* nelezi na jedne primce	    */
			if(a == b) continue;
			ab.x = bod_kuzelosecky[b].x - bod_kuzelosecky[a].x;
			ab.y = bod_kuzelosecky[b].y - bod_kuzelosecky[a].y;
			for(c = 1; c < 6; ++c) {
				if(a == c || b == c) continue;
				ac.x = bod_kuzelosecky[c].x - bod_kuzelosecky[a].x;
				ac.y = bod_kuzelosecky[c].y - bod_kuzelosecky[a].y;
				if(abs(ab.x * ac.y) == abs(ac.x * ab.y)) ++n;
			}
		}
	}
	if(n > 0) {
		chyba();
		return;
	}

	stred = prusecik_2primek(&bod_kuzelosecky[1], &bod_kuzelosecky[2],
						&bod_kuzelosecky[4], &bod_kuzelosecky[5]);
	if(stred == NULL) {     /* testovani rovnobeznosti primek */
		chyba();
		return;
	}
	I.x = stred->x;
	I.y = stred->y;

	dis();

	for( alfa = 0.0; alfa < 2 * M_PI; alfa += delta) {
						/* vypocet 'nahodneho' bodu resp. primky */
		bod_kuzelosecky[0].x = bod_kuzelosecky[1].x + cos(alfa);
		bod_kuzelosecky[0].y = bod_kuzelosecky[1].y + sin(alfa);

		stred = prusecik_2primek(&bod_kuzelosecky[1], &bod_kuzelosecky[0],
							&bod_kuzelosecky[3], &bod_kuzelosecky[4]);
		if(stred == NULL) {
			chyba();
			break;
		}
		III.x = stred->x;
		III.y = stred->y;

		stred = prusecik_2primek(&bod_kuzelosecky[2], &bod_kuzelosecky[3],
							&I, &III);
		if(stred == NULL) {
			chyba();
			break;
		}
		II.x = stred->x;
		II.y = stred->y;

		if(stred == NULL) {
			chyba();
			break;
		}
		stred = prusecik_2primek(&II, &bod_kuzelosecky[5],
							&bod_kuzelosecky[1], &bod_kuzelosecky[0]);
		if(stred == NULL) {
			chyba();
			break;
		}
		/* vykresleni noveho bodu */
		if(stred->x >= 0 && stred->x < 519 && stred->y >= 0 && stred->y < 439)
			putpixel((int) (stred->x), (int) (stred->y), YELLOW);
	}
	en();

return;
}

				/* pomocna funkce pro odstranovani chybovych stavu */
void chyba(void)
{
	int mm;

	bar(0, 440, 519, 459);
	outtextxy(260, 450, "Tri libovolne body nesmi lezet na jedne primce !");
	en();
	while(!status(3, &mm, &mm));
	bar(0, 440, 519, 459);
	clearviewport();
return;
}
